<?php
/**
 * Copyright © 2018 Filoblu S.p.A. All rights reserved.
 */

namespace FiloBlu\MappConnector\Block\Adminhtml\System\Config\Order;

/**
 * Class OrderItem
 * @package FiloBlu\MappConnector\Block\Adminhtml\System\Config\Order
 */
class OrderItem extends \FiloBlu\MappConnector\Block\Adminhtml\System\Config\AbstractConfig
{

    /**
     * Order Model
     *
     * @var \Magento\Sales\Model\Order\Item
     */
    protected $_model;

    /**
     * @var string
     */
    protected $_id = 'order_item';

    /**
     * @var string
     */
    protected $_type = 'flat';

    /**
     * @var array
     */
    protected $_exclude = ['entity_id'];

    /**
     * @var array
     */
    protected $_additionalOptions =  [
        ['value' => 'order_number', 'label' => 'Order Number'],
        ['value' => 'product_uri', 'label' => 'Product Uri'],
        ['value' => 'product_attribute_set', 'label' => 'Product Attribute Set'],
        ['value' => 'order_link', 'label' => 'Order Link'],
        ['value' => 'invoice_download_link', 'label' => 'Invoice Download Link'],
        ['value' => 'shipping_address', 'label' => 'Shipping Address'],
        ['value' => 'billing_address', 'label' => 'Billing Address'],
        ['value' => 'guest_customer_firstname', 'label' => 'Guest/Customer Firstname'],
        ['value' => 'guest_customer_lastname', 'label' => 'Guest/Customer Lastname']
    ];

    /**
     * Order constructor.
     * @param \Magento\Sales\Model\Order $order
     * @param \Magento\Backend\Block\Template\Context $context
     * @param array $data
     */
    public function __construct(
        \Magento\Sales\Model\Order\Item $orderItem,
        \Magento\Backend\Block\Template\Context $context,
        array $data = []
    ) {
        $this->_model = $orderItem;
        parent::__construct($context, $data);
    }


}